package explorviz.hpc_monitoring.byteaccess;

import java.lang.reflect.Field;
import sun.misc.Unsafe;

public class UnsafeBits {
    private static final Unsafe unsafe;
    static {
        try {
            final Field field = Unsafe.class.getDeclaredField("theUnsafe");
            field.setAccessible(true);
            unsafe = (Unsafe) field.get(null);
        }
        catch (final Exception e) {
            throw new RuntimeException(e);
        }
    }

    private static final long   byteArrayOffset = unsafe.arrayBaseOffset(byte[].class);

    public static final void putInt(final byte[] buffer, final int pos,
            final int value) {
        unsafe.putInt(buffer, byteArrayOffset + pos, value);
    }

    public static final int getInt(final byte[] buffer, final int pos) {
        return unsafe.getInt(buffer, byteArrayOffset + pos);
    }

    public static final void putLong(final byte[] buffer, final int pos,
            final long value) {
        unsafe.putLong(buffer, byteArrayOffset + pos, value);
    }

    public static final long getLong(final byte[] buffer, final int pos) {
        return unsafe.getLong(buffer, byteArrayOffset + pos);
    }
}